/* ident "@(#)ASM_INCLUDE:/usr/zoran/msps/asm/include/s.userasm.h 1.2 6/6/89" */
/**************************************************************************/
/*                                                                        */
/*    Copyright (c) 1989 ZORAN Corporation, All Rights Reserved           */
/*    THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ZORAN CORPORATION    */
/*                                                                        */
/*
 *    File : /usr/zoran/msps/asm/include/s.userasm.h
 *    Type : Header File
 *    Module : ASM_INCLUDE
 *    Sccs Identification (SID) : 1.2
 *    Modification Time : 6/6/89 15:21:22
 *                                                                        */
/*                                                                        */
/**************************************************************************/

#ifndef USERASM_H
#define USERASM_H

#define uint32 unsigned int long
#define int32 int long

enum zrintext { internal, external } ;
enum zrramsec { ram_sec_0=0, ram_sec_1=1 } ;
enum zrdtype  { real='R', imaginary='I', Complex='C', zigzag='Z', null='N' } ;

typedef struct {
    enum zrintext int_ext ;	/* internal or external operand */
    enum zrramsec ram_sec ;	/* internal ram section */
    enum zrdtype  data_type ;	/* internal ram portion */
    int		  offset ;	/* internal ram offset */
} zr325vec ;

#ifdef PROTOTYPE
extern int32 IEEE_Float( double ) ;
#else
extern int32 IEEE_Float() ;
#endif

extern char* zrSubEntryPrefix ;
extern char* zrSubExitPrefix ;
extern char* zrBlockEntryPrefix ;
extern char* zrBlockExitPrefix ;
extern char* zrFunctionDefinition ;
extern char* zrLocalDataLabel ;
#ifdef PROTOTYPE
char* zrMakeBlockLabel( char* prefix, char* name ) ;
#else
char* zrMakeBlockLabel() ;
#endif

#endif
/* ident "@(#)CBL:/usr/zoran/msps/cbl/s.cblasm.h 1.3 6/14/89" */
/**************************************************************************/
/*                                                                        */
/*    Copyright (c) 1989 ZORAN Corporation, All Rights Reserved           */
/*    THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ZORAN CORPORATION    */
/*                                                                        */
/*
 *    File : s.cblasm.h
 *    Type : Header File
 *    Module : CBL
 *    Sccs Identification (SID) : 1.3
 *    Modification Time : 6/14/89 15:54:17
 *                                                                        */
/*                                                                        */
/**************************************************************************/

/* 
 * File: CBLASM.H
 * Interface between CBL and ASM
 */

extern int32 zrLocalDataIndex;

#ifdef PROTOTYPE
extern void zrWriteInst( uint32* ary ) ;
#ifdef c_plusplus
extern void zrPutDataAtEndOfSub(
	uint32 value, 
	enum MaskTypes MaskType, 
	int NameRefFlag = 1
) ;
#else
extern void zrPutDataAtEndOfSub(
	uint32 value, 
	int MaskType, 
	int NameRefFlag
) ;
#endif
#else
extern void zrWriteInst() ;
extern void zrPutDataAtEndOfSub() ;
#endif
/* ident "@(#)CBL:/usr/zoran/msps/cbl/s.cblintfc.h 1.2 6/14/89" */
/**************************************************************************/
/*                                                                        */
/*    Copyright (c) 1989 ZORAN Corporation, All Rights Reserved           */
/*    THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ZORAN CORPORATION    */
/*                                                                        */
/*
 *    File : s.cblintfc.h
 *    Type : Header File
 *    Module : CBL
 *    Sccs Identification (SID) : 1.2
 *    Modification Time : 6/14/89 15:58:35
 *                                                                        */
/*                                                                        */
/**************************************************************************/

#ifndef CBLINTFC_H
#define CBLINTFC_H

#ifdef PROTOTYPE
/*
 * In first line and on every #include of file generate a call to 
 * zrPushFile.
 */
extern void zrPushFile(char *Name);

/*
 * On every end of file generate a call to zrPopFile.
 */
extern void zrPopFile( void );

/*
 * On definition of subroutine generate a call to zrSubroutine.
 * Name is the subroutine name.
 * SrcLine is the source line of the subroutine definition.
 */
extern void zrSubroutine(char *Name);

/*
 * On subroutine end generate a call to zrEndSubroutine.
 */
extern void zrEndSubroutine( void );

/*
 * On ORG pseudo instruction generate a call to zrOrg.
 * Addr is the ORG address. If (Addr == (-1)) then the ORG is not active any 
 * more.
 */
extern void zrOrg(int32 Addr);

/*
 * On ZSP-325 instruction generate a call to zrInst.
 * Inst is a pointer to array of 2 words of the instruction.
 */
extern void zrInst(uint32 *Inst);

/*
 * On initialization of data generate a call to zrInitData.
 */
extern void zrInitData(int32 value);

/*
 * On allocation of un initialized data area generate a call to zrUnInitData.
 */
extern void zrUnInitData(int32 Size);

/*
 * On any name definition (label or data) generate a call to zrName.
 * Labels inside subroutine with name with prefix '_SubEntry_' and suffix
 * identical to the subroutine name are global labels, otherwise local 
 * labels. Names outside subroutine are global.
 */
extern void zrName(char *Name);

/*
 * On any reference to label generate a call to zrNameRef.
 * The call to zrNameRef must be followed immediately by a call to zrInst 
 * of the instruction that keep the reference.
 * MaskType is the type of reference (One of MASK32_32, MASK24_0, MASK20_0, 
 *  MASK19_0)
 */
#ifdef c_plusplus
extern void zrNameRef(char *Name, enum MaskTypes MaskType);
#else
extern void zrNameRef(char *Name, int MaskType);
#endif

/*
 * To generate source listing generate a call to zrSourceCode on any
 * ZSP-325 source line.
 */
extern void zrSourceCode(char *ProgLine, int SrcLine);

/*
 * When a field value should be calculated and translated from logical to
 * literal during CBL run generate a call to zrlogfld befor the call to zrInst.
 */
extern void zrlogfld(char *FieldName, int32 val);

/*
 * When a field value should be calculated during CBL run generate a call to 
 * zrlitfld befor the call to zrInst.
 */
extern void zrlitfld(char *FieldName, int32 val);

/*
 * When linear MBS and MSS fields are specified in an instructon generate a 
 * call to zrBlockSkipProcessing befor the call to zrInst.
 */
extern void zrBlockSkipProcessing(char *InsName,int32 mbs,int32 mss,int32 rv);
extern void zrGenLDRMBS_MSS( int32 mbs, int32 mss ) ;

#ifndef ZRPRINT
#ifdef c_plusplus
extern int zrPrintError (enum MsgTypes ErrorType, const char *format_spec, ...);
#else
extern int zrPrintError (int ErrorType, const char *format_spec, ...);
#endif
#endif

extern void zrCheckMatrixParam(int32 ColA, int32 RowB);
extern void zrCheckMatrixB(int32 Col, int32 Row);
extern void zrCheckMatrixSize(int32 RowA, int32 ColA, int32 RowB, int32 ColB, 
	char *ins, char *CodeOp);
extern void zrSetRomDegrees(char * Field, int32 degrees);
extern void zrCheckRomAddress(int32 address);
extern void zrCheckSizeInterval(char *msg, int32 size, int32 low, int32 high);
extern void zrCheckSizeEven(int32 size);
extern void zrCheckSizePower2(int32 size);
extern void zrCheckSizeRegister(int32 size);
extern void zrCheckSizeZigZag(int32 size);
extern void zrCheckSizeRepeatInterval(int32 size, int32 repeat, int32 low, 
	int32 high);
extern void zrCheckSizeRepeatRegister(int32 size, int32 repeat);
extern void zrCheckRamSectionNumber(int32 rs);
extern void zrCheckRamOffset(int32 offset);
#ifdef c_plusplus
extern int32 zrSetDisplacement(int32 disp, enum MaskTypes type);
extern void zrCheckAddressExpression(int32 address, enum MaskTypes type);
#else
extern int32 zrSetDisplacement(int32 disp, int type);
extern void zrCheckAddressExpression(int32 address, int type);
#endif
extern void zrCheckRepeatEven(int32 repeat);
extern void zrCheckSizeRepeatPower(int32 size, int32 repeat);

#else

extern void zrPushFile();
extern void zrPopFile();
extern void zrSubroutine();
extern void zrEndSubroutine();
extern void zrOrg();
extern void zrInst();
extern void zrInitData();
extern void zrUnInitData();
extern void zrName();
extern void zrNameRef();
extern void zrSourceCode();
extern void zrlogfld();
extern void zrlitfld();
extern void zrBlockSkipProcessing();
extern void zrGenLDRMBS_MSS() ;

extern int zrPrintError ();
extern void zrCheckMatrixParam();
extern void zrCheckMatrixB();
extern void zrCheckMatrixSize();
extern void zrSetRomDegrees();
extern void zrCheckRomAddress();
extern void zrCheckSizeInterval();
extern void zrCheckSizeEven();
extern void zrCheckSizePower2();
extern void zrCheckSizeRegister();
extern void zrCheckSizeZigZag();
extern void zrCheckSizeRepeatInterval();
extern void zrCheckSizeRepeatRegister();
extern void zrCheckRamSectionNumber();
extern void zrCheckRamOffset();
extern int32 zrSetDisplacement();
extern void zrCheckAddressExpression();
extern void zrCheckRepeatEven();
extern void zrCheckSizeRepeatPower();
#endif

#endif
