echo "\n"
echo "-------------------------\n"
echo "Programming demonstration\n"
echo "-------------------------\n"
echo "\n"
echo "The following program will filter out the noise from the input signal.\n"
echo "\n"
echo "The filter will be done in the frequency domain:\n"
echo "FFT of the input signal, Low Pass Filter through multiplication\n"
echo "with a window in the frequency domain and then Inverse FFT .\n"
echo "\n"
echo "Since the desired signal falls in the first FFT bin while\n"
echo "the noise components have much higher frequency, a simple window\n"
echo "with 1.0 in the first bin is enough.\n"
pause
echo "\n"
echo "The following program resides in %zsps%\demo\lpf.asm and was previously\n"
echo "assembled and linked using ASM325 and LINK325.\n"
echo "\n"
type "$ZSPS\demo\lpf.asm"
echo "\n"
pause
echo "To run this program we first load it to the external RAM.\n"
echo "> load $ZSPS\demo\lpf.exz\n"
echo "\n"
restart
load "$ZSPS\demo\lpf.exz"
echo "\n"
pause
echo "Before running the program let's set the message_level to `instruction'\n"
echo "to allow for more detailed listing:\n"
echo "\n"
echo "> gset message instruc\n"
gset message instruc
echo "\n"
pause
echo "Now we can run the program:\n"
echo "To demonstarte the Timing Analyzer, first change mode of simulation to\n"
echo " timing mode by: gset run_mode timing\n"
gset run_mode timing
echo "next run 3 instructions\n"
echo "> run 3 instruction\n"
echo " and then examine the status of the ZSP.\n"
run 3 instruction -1
echo "> sshow\n"
sshow -1
pause
echo "Now we will continue the run to the end of the program.\n"
echo "> run\n"
run -1 instruction -1
echo "To check how many clocks took this program to finish let's do:\n"
echo "gshow\n"
gshow
echo "\n"
