
/**************************************************************/
/* Cross Correlation                                          */
/* Description: Takes 2 input vectors, as frequency spectrums */
/* and computes the inverse fourier transform of X time the   */
/* conjugate of Y.  The Output is shifted by the signal block */
/* offset.                                                    */
/* Note: The values in the Y array are destroyed by this      */
/* operation                                                  */
/**************************************************************/


zsp325()
{
/#
.ORG 0
.DATA In_Data1   2048;
.DATA In_Data2   2048;
.DATA Out_Data1  2048;
.DATA Out_Data2  2048;
.DATA tmp_addr 4;

 SUBROUTINE CCORR_1024(zr325ref X, zr325ref Y, zr325ref tmp)
 {
   LDR #0x50f201 => $MODE;  /* one memory section */
   LDR X => $A;     /* get the first input pointer */
   LDR Y => $B;     /* get the second input pointer */
   ADDR #-128,[$A]; /* offset the registers to use pre_increment addr */
   ADDR #-128,[$B]; /* offset the registers to use pre_increment addr */
   LDR #16 => $LC;   /* 16 blocks of 64 is 1024 points */
   CORR_LOOP_1024::
     LD_*C:(64) $B+=128  => $C0; /* get the first segment of Y, Complex Conj */
     MULT_C:(64) $A+=128 => $C0; /* convert the segment in memory */
     ST_C:(64)  $C0     => $B;  /* save the results */
     JMPC:[DL] [!LZ], CORR_LOOP_1024;
   /* now, do the IFFT */
   CALL CIFFT(1024,Y,tmp);
    
 }

SUBROUTINE MAIN() {    /* initialize the stack, etc. Done in Main */
   CALL CCORR_1024(&In_Data1,&In_Data2,&Out_Data1);
   HLT;
}   
   
#/
}
