
/**************************************************************/
/* Int_to_FP Routine                                          */
/* Description: Takes an input vectors and converts from a    */
/* 16 bit twos-complement representation to an IEEE floating  */
/* point number (32 bit)                                      */
/**************************************************************/
zsp325()
{
/#
   SUBROUTINE FLOAT_TO_INT_64(zr325ref input,zr325ref output)
   {
          
      LDR #0x50f201 => $MODE;
      LDR input => $A;
      LDR output => $B;/* get the output pointer */
      LD_C:(32) $A => $C0;  /* get the first segment */
      FPINT_C:(32) $C0 => $C0 ;  /* convert the segment in memory */
      ST_C:(32) $C0 => $B; /* store the first segment */
   }
   SUBROUTINE FLOAT_TO_INT_128(zr325ref input,zr325ref output)
   {
          
      LDR #0x50f201 => $MODE;
      LDR input => $A;
      LDR output => $B;/* get the output pointer */
      ADDR #-64,[$A,$B]; /* offset the registers to use pre_increment addr */
      LD_C:(32) $A+=64 => $C0;  /* get the first segment */
      FPINT_C:(32) $C0 => $C0 ;  /* convert the segment in memory */
      LD_C:(32) $A+=64 => $C1; /* get next segment */
      FPINT_C:(32) $C1 => $C1 ;  /* convert the segment in memory */
      ST_C:(32) $C0 => $B+=64; /* store the first segment */
      ST_C:(32) $C1 => $B+=64; /* store the second segment */
   }

   SUBROUTINE FLOAT_TO_INT_256(zr325ref input,zr325ref output)
   {
          
      LDR #0x50f201 => $MODE;
      LDR input => $A;
      LDR output => $B;/* get the output pointer */
      ADDR #-64,[$A,$B]; /* offset the registers to use pre_increment addr */
      LDR #2 => $LC;  /* loop twice */
FPINT_LOOP_256::
      LD_C:(32) $A+=64 => $C0;  /* get the first segment */
      FPINT_C:(32) $C0 => $C0 ;  /* convert the segment in memory */
      LD_C:(32) $A+=64 => $C1; /* get next segment */
      FPINT_C:(32) $C1 => $C1 ;  /* convert the segment in memory */
      ST_C:(32) $C0 => $B+=64; /* store the first segment */
      ST_C:(32) $C1 => $B+=64; /* store the second segment */
      JMPC:[DL] [!LZ], FPINT_LOOP_256;
   }

   SUBROUTINE FLOAT_TO_INT_512(zr325ref input,zr325ref output)
   {
          
      LDR #0x50f201 => $MODE;
      LDR input => $A;
      LDR output => $B;/* get the output pointer */
      ADDR #-64,[$A,$B]; /* offset the registers to use pre_increment addr */
      LDR #4 => $LC;  /* loop twice */
FPINT_LOOP_512::
      LD_C:(32) $A+=64 => $C0;  /* get the first segment */
      FPINT_C:(32) $C0 => $C0 ;  /* convert the segment in memory */
      LD_C:(32) $A+=64 => $C1; /* get next segment */
      FPINT_C:(32) $C1 => $C1 ;  /* convert the segment in memory */
      ST_C:(32) $C0 => $B+=64; /* store the first segment */
      ST_C:(32) $C1 => $B+=64; /* store the second segment */
      JMPC:[DL] [!LZ], FPINT_LOOP_512;
   }

   SUBROUTINE FLOAT_TO_INT_1024(zr325ref input,zr325ref output)
   {
          
      LDR #0x50f201 => $MODE;
      LDR input => $A;
      LDR output => $B;/* get the output pointer */
      ADDR #-64,[$A,$B]; /* offset the registers to use pre_increment addr */
      LDR #8 => $LC;  /* loop twice */
FPINT_LOOP_1024::
      LD_C:(32) $A+=64 => $C0;  /* get the first segment */
      FPINT_C:(32) $C0 => $C0 ;  /* convert the segment in memory */
      LD_C:(32) $A+=64 => $C1; /* get next segment */
      FPINT_C:(32) $C1 => $C1 ;  /* convert the segment in memory */
      ST_C:(32) $C0 => $B+=64; /* store the first segment */
      ST_C:(32) $C1 => $B+=64; /* store the second segment */
      JMPC:[DL] [!LZ], FPINT_LOOP_1024;
   }

#/
}
