#define VECTOR_SIZE  128

/**************************************************************/
/* Int_to_FP Routine                                          */
/* Description: Takes an input vectors and converts from a    */
/* 16 bit twos-complement representation to an IEEE floating  */
/* point number (32 bit)                                      */
/**************************************************************/
zsp325()
{
   int size;
   int i;
   size = VECTOR_SIZE;
#ifdef JUNKKKKKKIKKKKKK
/#
   SUBROUTINE INT_TO_FLOAT(zr325ref input,zr325ref output)
   {
   LD_R input => $A;
   LD_R output => $B;
   SUB_R #64 => $A,$B; /* offset the registers to use pre_increment addr */
#/
   /* first load the initial segment into VSP memory.  Use complex for
      better usage of internal memory */
   if(VECTOR_SIZE > 64) { 
      /# LD_C:(32) $A+=64 => $0; #/ /* get the first segment */
      for(i = 0; i < VECTOR_SIZE; i += 128){ /* 64 elt in internal mem */
         /# INTFP_C(32) $0 => $0 ; #/  /* convert the segment in memory */
         if(((i * 128 + 128 ) < VECTOR_SIZE) {  /* at least 64 vals left */
            /# LD_C:(32) $A+=64 => $1; #/ /* get next segment */
            /# INTFP_C(32) $1 => $1 ; #/  /* convert the segment in memory */
         }
         ST_C:(32) $0 => $A+=64; /* store the first segment */
      }

#endif

/#
   SUBROUTINE INT_TO_FLOAT128(zr325ref input,zr325ref output)
   {
          
      LD_R input => $A; /* get the input pointer */
      LD_R output => $B;/* get the output pointer */
      SUB_R #64 => $A,$B; /* offset the registers to use pre_increment addr */
      LD_C:(32) $A+=64 => $0;  /* get the first segment */
      INTFP_C(32) $0 => $0 ;  /* convert the segment in memory */
      LD_C:(32) $A+=64 => $1; /* get next segment */
      INTFP_C(32) $1 => $1 ;  /* convert the segment in memory */
      ST_C:(32) $0 => $A+=64; /* store the first segment */
      ST_C:(32) $1 => $A+=64; /* store the second segment */
   }
   
   SUBROUTINE MAIN()
   {
       .DATA inp 128;
       .DATA out 128;
       CALL INT_TO_FLOAT128(&inp,&out);
   }
#/
