

/**************************************************************/

/* Max       Routine                                          */

/* Description: Takes an input vectors and locates a spec'd   */

/* number of peaks.  The peaks are stored in a buffer as:     */

/* Peak Center Index(PCI), in[PCI-1],in[PCI],in[PCI+1]        */

/* After each peak is located, it is zeroed out in the input  */

/* Note that the input array is damaged after finding peaks   */

/**************************************************************/

zsp325()

{

/#

.ORG 0x01A000;

.DATA In_Data 1024;

.ORG 0x01B000;

.DATA Out_Data 256;

.DATA In_Ptr  {&In_Data};

.DATA Out_Ptr  {&Out_Data};

.ORG 0x010000 ;

   SUBROUTINE MAX_128(zr325ref in,zr325ref out,zr325val num_peaks)

   {

          

      LDR #0x50f201 => $MODE;

      LDR num_peaks => $LC;  /* set up the loop counter */

      LDR out => $A;/* get the output pointer */

      ADDR $A,#-3; /* compensate for pre-autoincrement addressing */

      MAX128LOOP::

          LDR in => $B;

          MAX:(4,32) $B => $MNMX; /* find max */

          STR $MNMXI => $A+=3;

          ADDR $B, $A => $X ;

          ADDR $B,#-1; /* sub 1 to get a region of 3 */

          LD_R:(3) $B => $R0; /* get the region, zero other internal mem */

          ST_R:(3) $R0 => $A+=1; /* store the region, inc pointer */

          ST_R:(3) $R0+4 => $B; /* and zero out the region */

          JMPC:[DL] [!LZ], MAX128LOOP;

   }



SUBROUTINE MAIN() {



   CALL MAX_128(&In_Data,&Out_Data,10);

} 



#/

}

