zsp325() {

    int i;

/#

.ORG 0x010000;

.DATA In_Data   2048;

.ORG 0x011000;

.DATA Complex_Data   2048;

.ORG 0x012000;

.DATA Win_Data  2048;

.ORG 0x013000;

.DATA Magnitude_Data  2048;

.ORG 0x014000;

.DATA Freq_Peak_Data  2048;

.ORG 0x015000;

.DATA Scratch_Data  2048;
.ORG 0x016000;

.DATA Track_Data  2048;

.ORG 0x080;

.DATA PARAM_A {&In_Data};

.DATA PARAM_B {&Complex_Data};

.DATA PARAM_C {&Win_Data};

.DATA PARAM_D {&Magnitude_Data};

.DATA PARAM_E {&Freq_Peak_Data};

.DATA PARAM_F {&Scratch_Data};

.DATA PARAM_G {&Track_Data};



SUBROUTINE MAG_64(zr325ref, zr325ref);

SUBROUTINE MAG_128(zr325ref, zr325ref);

SUBROUTINE MAG_256(zr325ref, zr325ref);

SUBROUTINE MAG_512(zr325ref, zr325ref);

SUBROUTINE MAG_1024(zr325ref, zr325ref);



SUBROUTINE INT_TO_FLOAT_8(zr325ref, zr325ref);

SUBROUTINE INT_TO_FLOAT_16(zr325ref, zr325ref);

SUBROUTINE INT_TO_FLOAT_32(zr325ref, zr325ref);

SUBROUTINE INT_TO_FLOAT_64(zr325ref, zr325ref);

SUBROUTINE INT_TO_FLOAT_128(zr325ref, zr325ref);

SUBROUTINE INT_TO_FLOAT_256(zr325ref, zr325ref);

SUBROUTINE INT_TO_FLOAT_512(zr325ref, zr325ref);

SUBROUTINE INT_TO_FLOAT_1024(zr325ref, zr325ref);



SUBROUTINE INT_TO_FLOAT_WIND_8(zr325ref, zr325ref);

SUBROUTINE INT_TO_FLOAT_WIND_16(zr325ref, zr325ref);

SUBROUTINE INT_TO_FLOAT_WIND_32(zr325ref, zr325ref);

SUBROUTINE INT_TO_FLOAT_WIND_64(zr325ref, zr325ref);

SUBROUTINE INT_TO_FLOAT_WIND_128(zr325ref, zr325ref);

SUBROUTINE INT_TO_FLOAT_WIND_256(zr325ref, zr325ref);

SUBROUTINE INT_TO_FLOAT_WIND_512(zr325ref, zr325ref);

SUBROUTINE INT_TO_FLOAT_WIND_1024(zr325ref, zr325ref);



SUBROUTINE MAX_8(zr325ref, zr325ref, zr325val);

SUBROUTINE MAX_16(zr325ref, zr325ref, zr325val);

SUBROUTINE MAX_32(zr325ref, zr325ref, zr325val);

SUBROUTINE MAX_64(zr325ref, zr325ref, zr325val);

SUBROUTINE MAX_128(zr325ref, zr325ref, zr325val);

SUBROUTINE MAX_256(zr325ref, zr325ref, zr325val);

SUBROUTINE MAX_512(zr325ref, zr325ref, zr325val, zr325ref);

SUBROUTINE MAX_1024(zr325ref, zr325ref, zr325val);


SUBROUTINE PEAK_HOLD_512(zr325ref , zr325ref );




.ORG 0x090 ;

SUBROUTINE MAIN() {    /* initialize the stack, etc. Done in Main */

   LDR #0x50f601 => $MODE;

   JMP PROCESS_ALL_1024;
   NOP;

   HLT;

   HLT;



FFT_512::

   CALL RFFT(512,PARAM_A,PARAM_B);

   NOP;

   HLT;

   HLT;

FFT_1024::

   CALL RFFT(1024,PARAM_A,PARAM_B);

   NOP;

   HLT;

   HLT;

CFFT_512::

   CALL CFFT(512,PARAM_A,PARAM_B);

   NOP;

   HLT;

   HLT;

CFFT_1024::

   CALL CFFT(1024,PARAM_A,PARAM_B);

   NOP;

   HLT;

   HLT;

RLOG10_512::

   CALL RLOG10(512,PARAM_A,PARAM_B);

   NOP;

   HLT;

   HLT;

RLOG10_1024::

   CALL RLOG10(1024,PARAM_A,PARAM_B);

   NOP;

   HLT;

   HLT;

RMULT_512::

   CALL RMULT(512,PARAM_A,PARAM_B,PARAM_C);

   NOP;

   HLT;

   HLT;

RMULT_1024::

   CALL RMULT(1024,PARAM_A,PARAM_B,PARAM_C);

   NOP;

   HLT;

   HLT;

RMAG_512::

   CALL MAG_512(PARAM_A,PARAM_B);

   NOP;

   HLT;

   HLT;

RMAG_1024::

   CALL MAG_1024(PARAM_A,PARAM_B);

   NOP;

   HLT;

   HLT;

INTFP_512::

   CALL INT_TO_FLOAT_512(PARAM_A,PARAM_B);

   NOP;

   HLT;

   HLT;

INTFP_1024::

   CALL INT_TO_FLOAT_1024(PARAM_A,PARAM_B);

   NOP;

   HLT;

   HLT;

MAX_512::

   CALL MAX_512(PARAM_A,PARAM_B,PARAM_C,PARAM_D);

   NOP;

   HLT;

   HLT;





/* Parameters:

      Param_A  :  Input Time Domain Signal (Real-Integer)    Size=N

      Param_B  :  Output Complex Frequencies (Complex-Float) Size=2N+2

      Param_C  :  Input Window Function (Real-Float)         Size=N

      Param_D  :  Magnitude Frequency (Real-Float)           Size=N

                  (valid output for N/2 points)

      Param_E  :  Frequency Peaks                            Size=10*4

                  (valid output for 10 peaks)

      Param_F  :  Temporary memory buffer for peak detection

      Param_G  :  Frequency Tracking buffer

*/



PROCESS_ALL_1024:: /* tbd baa hack */

   /* do an in-place int-to-fp conversion, and windowing multiply */

   CALL INT_TO_FLOAT_WIND_1024(PARAM_A,PARAM_C);

   /* compute the real FFT on buffer A, and put the results in B */

   CALL RFFT(1024,PARAM_A,PARAM_B);

   /* calc the magnitude and store it in buffer D */

   CALL MAG_512(PARAM_B,PARAM_D);

   /* locate the magnitude peaks and store in buffer E */

   CALL MAX_512(PARAM_D,PARAM_E,10,PARAM_F);

   CALL PEAK_HOLD_512(PARAM_D,PARAM_G);

/*  SUBROUTINE PEAK_HOLD_512(zr325ref in, zr325ref max) */

   NOP;

   HLT;

   HLT;

}



#/

}

