zsp325()
{
#ifdef TEST 
/#
.ORG 0
.DATA New_Data   512;
.DATA Peak_Data  512;
#/
#endif
/#

 SUBROUTINE PEAK_HOLD_512(zr325ref in, zr325ref max)
 {
   LDR #0x50f200 => $MODE;  /* no store arith, rnd to nearest,no trap,2 mem sect
                               no freeze,2 clks/cyc, async stbs, no rst, 16bit ints
                               concurrent exec,statys pins=busreq,16 meg mem,
                               int=output,enable int, no xor */

   LDR in  => $A;     /* get the first input pointer */
   LDR max => $B;     /* get the second input pointer */
   ADDR #-32,[$A]; /* offset the registers to use pre_increment addr */
   ADDR #-32,[$B]; /* offset the registers to use pre_increment addr */
   LDR #16 => $LC; /* 32 points each iter, 16 iters = 512 points */
   PEAK_HOLD_LOOP::
      LD_R:(32) $A+=32      => $R0; /* get the first segment of max */
      LD_I:(32) $B+=32      => $I0; /* get the first segment of in */
      CMP_R:(32) $I0,$R0 => $R1; /* compare the segments in memory */
      MULT_R:(32) $I0, $R1 => $I0; /* Get the higher samples in I0 */
      SUB_(R,R) #1.0, $C1 => $R1; /* save the complement */
      TRAN_(I,R) $C1 => $C1;
      MULT_R:(32) $R0, $I1 => $R0; /* Get the higher samples in A */
      ADD_R:(32) $R0, $I0 => $R0;
      ST_R:(32)  $R0   => $B;  /* save the results max > in */
      JMPC:[DL] [!LZ], PEAK_HOLD_LOOP;         
 }
#/
#ifdef TEST 
/#
SUBROUTINE MAIN() {    /* initialize the stack, etc. Done in Main */
   CALL PEAK_HOLD_512(&New_Data,&Peak_Data);
   CALL PEAK_HOLD_512(&New_Data,&Peak_Data);
   HLT;
} 
#/  
#endif
}
